package com;

import com.GraphColoringProblem;
import com.Graph;
import com.org.math.plot.Plot2DPanel;

import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.swing.JFrame;

public class Main {
	public static int genSize = 0;
	public static int colorNum = 0;
	public static int popSize = 0;
	public static int chromNum = 0;
	public static double mutRate = 0.0;
	public static double crossRate = 0.0;
	static Graph graf;
	
	public static void main(String[] args){
		System.out.println("Genetic Algorithm applied to the Graph Coloring Problem");
		getParameters();
		GraphColoringProblem gcp = new GraphColoringProblem(graf, colorNum, false, true);
        final GeneticAlgorithm<Integer> ea = new GeneticAlgorithm<>(gcp, popSize, chromNum, crossRate, mutRate, genSize);
        new Thread(new Runnable() {
                @Override
                public void run() {
                    ea.run();
                }
            }).start();
            do {
                try {
                    Thread.sleep(1000);
                    System.out.printf("Iteration: %d  Fval: %.6f\n", ea.iterations, ea.bestSolutionCost);
                } catch (InterruptedException ex) {
                    Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
                }
            } while (ea.isRunning());
            
        System.out.println("Mejor resultado: " + ea.bestSolutionCost + " Número de iteraciones: " + ea.iterations);
	}
	
	public static void getParameters(){
		Scanner scanner = new Scanner(System.in);
		System.out.println("Give me the generations number");
		genSize = Integer.valueOf(scanner.next());
		System.out.println("Give me the number of colors");
		colorNum = Integer.valueOf(scanner.next());
		System.out.println("Give me the population size");
		popSize = Integer.valueOf(scanner.next());
		System.out.println("Give me the chromosome number");
		chromNum = Integer.valueOf(scanner.next());
		System.out.println("Give me the mutation rate");
		mutRate = Double.valueOf(scanner.next());
		System.out.println("Give me the crossover rate");
		crossRate = Double.valueOf(scanner.next());
		
		System.out.println("***********************************");
		System.out.println("************PARAMETERS*************");
		System.out.println("***********************************");
		System.out.println("Generations: " + genSize);
		System.out.println("Population: " + popSize);
		System.out.println("Chromosome length: " + chromNum);
		System.out.println("Mutation rate: " + mutRate);
		System.out.println("Crossover rate: " + crossRate);
		graf = new Graph();
		try {
            graf.loadFromFile("miles500.col");
        } catch (FileNotFoundException ex) {
            System.err.println("File not found.");
            System.exit(-1);
        }
        Integer[] result = null;

        result = NotEvolutionAlgorithms.solveSmallestFirst(graf);

        int max = 0;
        for (int i = 0; i < result.length; ++i) {
            max = max > result[i] ? max : result[i];
        }
	}
}
